#ifndef TreeWidget_h
#define TreeWidget_h

#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>

class TreeWidget : public QTreeWidget
{
	Q_OBJECT

public:
	TreeWidget();

protected:
	virtual void commitData(QWidget* pEditor) override;
	virtual QStringList mimeTypes() const override;
	virtual QMimeData* mimeData(const QList<QTreeWidgetItem*> items) const override;
	virtual bool dropMimeData(QTreeWidgetItem* pParent, int iIndex, const QMimeData* pData, Qt::DropAction dropaction) override;

	virtual Qt::DropActions supportedDropActions() const override;
	virtual void startDrag(Qt::DropActions supportedActions) override;
	virtual void dragEnterEvent(QDragEnterEvent* pEvent) override;
	virtual void dragMoveEvent(QDragMoveEvent* pEvent) override;
	virtual void dragLeaveEvent(QDragLeaveEvent* pEvent) override;
	virtual void dropEvent(QDropEvent* pEvent) override;

private:
	bool m_bDragStarted;
	mutable QStringList m_listMimeTypes;
	mutable QTreeWidgetItem* m_pDragItem;
};

#endif // TreeWidget_h
